'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClientResolver = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactRouter = require('react-router');

var _locationStorage = require('./../locationStorage');

var _createResolver = require('./createResolver');

var createClientResolver = exports.createClientResolver = function createClientResolver(history, routes) {
  var custom = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var resolver = (0, _createResolver.createResolver)();
  var locationStorage = (0, _locationStorage.createLocationStorage)();

  var transitionRule = function transitionRule(lastLocation, newLocation) {
    return lastLocation.pathname !== newLocation.pathname || lastLocation.search !== newLocation.search;
  };

  var setTransitionRule = function setTransitionRule(rule) {
    transitionRule = rule;
  };

  var isTransition = function isTransition(location) {
    return transitionRule(locationStorage.getLastLocation(), location);
  };

  history.listenBefore(function (location, continueTransition) {
    if (!isTransition(location)) return;
    (0, _reactRouter.match)({ history: history, location: location, routes: routes }, function (error, redirectLocation, renderProps) {
      if (renderProps) {
        var components = renderProps.components;
        var params = renderProps.params;

        var attrs = _extends({}, custom, { location: location, params: params });
        resolver.triggerHooks(components, attrs, function () {
          continueTransition();
          locationStorage.setNewLocation(location);
        });
      }
    });
  });

  return _extends({}, resolver, {
    setTransitionRule: setTransitionRule
  });
};